/*
 * TUX - Integrated HTTP layer and Object Cache
 *
 * Copyright (C) 2000, Ingo Molnar <mingo@redhat.com>
 *
 * parser.h: generic parsing routines
 */

#define get_c(ptr)						\
({								\
	unsigned char __ret = *(ptr);				\
								\
	if (__ret == '\r') {					\
		unsigned char __next = *((ptr)+1);		\
								\
		if (__next == '\n' || !__next) {		\
			__ret = __next;				\
			(ptr)++;				\
		}						\
	}							\
	__ret;							\
})

#define PARSE_TOKEN(ptr,end,str)				\
	({							\
		int __ret;					\
								\
		if (ptr + sizeof(str)-1 > end)			\
			GOTO_INCOMPLETE;			\
								\
		if (memcmp(ptr, str, sizeof(str)-1))		\
			__ret = 0;				\
		else {						\
			ptr += sizeof(str)-1;			\
			__ret = 1;				\
		}						\
		__ret;						\
	})

#define PARSE_METHOD(req,ptr,end,name)				\
	({							\
		int __ret;					\
								\
		if (PARSE_TOKEN(ptr,end,#name" ")) {		\
			req->method = METHOD_##name;		\
			__ret = 1;				\
		} else						\
			__ret = 0;				\
		__ret;						\
	})

#define COPY_LINE(target)					\
	do {							\
		while (get_c(curr) != '\n') {			\
			if (!*curr)				\
				GOTO_INCOMPLETE;		\
			*target++ = *curr;			\
			curr++;					\
		}						\
	} while (0)

#define COPY_FIELD(target)					\
	do {							\
		while (get_c(curr) != ' ') {			\
			if (!*curr)				\
				GOTO_INCOMPLETE;		\
			*target++ = *curr;			\
			curr++;					\
		}						\
	} while (0)

#define SKIP_LINE						\
	do {							\
		while (get_c(curr) != '\n') {			\
			if (!*curr)				\
				GOTO_INCOMPLETE;		\
			curr++;					\
		}						\
	} while (0)

